/* valacallabletype.c generated by valac, the Vala compiler
 * generated from valacallabletype.vala, do not modify */

/* valacallabletype.vala
 *
 * Copyright (C) 2017  Rico Tzschichholz
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Rico Tzschichholz <ricotz@ubuntu.com>
 */

#include "vala.h"
#include <glib.h>
#include <valagee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

static gpointer vala_callable_type_parent_class = NULL;

static gboolean vala_callable_type_real_is_invokable (ValaDataType* base);
static ValaDataType* vala_callable_type_real_get_return_type (ValaDataType* base);
static ValaList* vala_callable_type_real_get_parameters (ValaDataType* base);
static gchar* vala_callable_type_real_to_prototype_string (ValaDataType* base,
                                                    const gchar* override_name);
static GType vala_callable_type_get_type_once (void);

ValaCallable*
vala_callable_type_get_callable_symbol (ValaCallableType* self)
{
	ValaCallable* result;
	ValaSymbol* _tmp0_;
	ValaSymbol* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = vala_data_type_get_symbol ((ValaDataType*) self);
	_tmp1_ = _tmp0_;
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, VALA_TYPE_CALLABLE, ValaCallable);
	return result;
}

ValaCallableType*
vala_callable_type_construct (GType object_type,
                              ValaSymbol* symbol)
{
	ValaCallableType* self = NULL;
	g_return_val_if_fail (symbol != NULL, NULL);
	self = (ValaCallableType*) vala_data_type_construct_with_symbol (object_type, symbol);
	return self;
}

static gboolean
vala_callable_type_real_is_invokable (ValaDataType* base)
{
	ValaCallableType * self;
	gboolean result = FALSE;
	self = (ValaCallableType*) base;
	result = TRUE;
	return result;
}

static ValaDataType*
vala_callable_type_real_get_return_type (ValaDataType* base)
{
	ValaCallableType * self;
	ValaCallable* _tmp0_;
	ValaCallable* _tmp1_;
	ValaDataType* _tmp2_;
	ValaDataType* _tmp3_;
	ValaDataType* result = NULL;
	self = (ValaCallableType*) base;
	_tmp0_ = vala_callable_type_get_callable_symbol (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = vala_callable_get_return_type (_tmp1_);
	_tmp3_ = _tmp2_;
	result = _tmp3_;
	return result;
}

static ValaList*
vala_callable_type_real_get_parameters (ValaDataType* base)
{
	ValaCallableType * self;
	ValaCallable* _tmp0_;
	ValaCallable* _tmp1_;
	ValaList* _tmp2_;
	ValaList* result = NULL;
	self = (ValaCallableType*) base;
	_tmp0_ = vala_callable_type_get_callable_symbol (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = vala_callable_get_parameters (_tmp1_);
	result = _tmp2_;
	return result;
}

static gpointer
_vala_iterable_ref0 (gpointer self)
{
	return self ? vala_iterable_ref (self) : NULL;
}

static gchar*
vala_callable_type_real_to_prototype_string (ValaDataType* base,
                                             const gchar* override_name)
{
	ValaCallableType * self;
	GString* builder = NULL;
	GString* _tmp0_;
	ValaDataType* return_type = NULL;
	ValaDataType* _tmp1_;
	ValaDataType* _tmp2_;
	GString* _tmp4_;
	ValaDataType* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GString* _tmp8_;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_;
	GString* _tmp12_;
	GString* _tmp13_;
	GString* _tmp14_;
	gint i = 0;
	ValaDelegateType* delegate_type = NULL;
	ValaDelegateType* _tmp15_;
	GString* _tmp93_;
	ValaArrayList* error_types = NULL;
	GEqualFunc _tmp94_;
	ValaArrayList* _tmp95_;
	ValaArrayList* _tmp96_;
	ValaArrayList* _tmp97_;
	gint _tmp98_;
	gint _tmp99_;
	GString* _tmp113_;
	const gchar* _tmp114_;
	gchar* _tmp115_;
	gchar* result = NULL;
	self = (ValaCallableType*) base;
	_tmp0_ = g_string_new ("");
	builder = _tmp0_;
	_tmp1_ = vala_data_type_get_return_type ((ValaDataType*) self);
	return_type = _tmp1_;
	_tmp2_ = return_type;
	if (vala_data_type_is_weak (_tmp2_)) {
		GString* _tmp3_;
		_tmp3_ = builder;
		g_string_append (_tmp3_, "unowned ");
	}
	_tmp4_ = builder;
	_tmp5_ = return_type;
	_tmp6_ = vala_data_type_to_qualified_string (_tmp5_, NULL);
	_tmp7_ = _tmp6_;
	g_string_append (_tmp4_, _tmp7_);
	_g_free0 (_tmp7_);
	_tmp8_ = builder;
	g_string_append_c (_tmp8_, ' ');
	_tmp10_ = g_strdup (override_name);
	_tmp9_ = _tmp10_;
	if (_tmp9_ == NULL) {
		gchar* _tmp11_;
		_tmp11_ = vala_code_node_to_string ((ValaCodeNode*) self);
		_g_free0 (_tmp9_);
		_tmp9_ = _tmp11_;
	}
	_tmp12_ = builder;
	g_string_append (_tmp12_, _tmp9_);
	_tmp13_ = builder;
	g_string_append_c (_tmp13_, ' ');
	_tmp14_ = builder;
	g_string_append_c (_tmp14_, '(');
	i = 1;
	delegate_type = VALA_IS_DELEGATE_TYPE (self) ? ((ValaDelegateType*) self) : NULL;
	_tmp15_ = delegate_type;
	if (_tmp15_ != NULL) {
		ValaDelegate* delegate_symbol = NULL;
		ValaDelegateType* _tmp16_;
		ValaDelegate* _tmp17_;
		ValaDelegate* _tmp18_;
		gboolean _tmp19_ = FALSE;
		ValaDelegate* _tmp20_;
		ValaSymbol* _tmp21_;
		ValaSymbol* _tmp22_;
		_tmp16_ = delegate_type;
		_tmp17_ = vala_delegate_type_get_delegate_symbol (_tmp16_);
		_tmp18_ = _tmp17_;
		delegate_symbol = _tmp18_;
		_tmp20_ = delegate_symbol;
		_tmp21_ = vala_symbol_get_parent_symbol ((ValaSymbol*) _tmp20_);
		_tmp22_ = _tmp21_;
		if (VALA_IS_SIGNAL (_tmp22_)) {
			ValaDelegate* _tmp23_;
			ValaDataType* _tmp24_;
			ValaDataType* _tmp25_;
			_tmp23_ = delegate_symbol;
			_tmp24_ = vala_delegate_get_sender_type (_tmp23_);
			_tmp25_ = _tmp24_;
			_tmp19_ = _tmp25_ != NULL;
		} else {
			_tmp19_ = FALSE;
		}
		if (_tmp19_) {
			GString* _tmp26_;
			ValaDelegate* _tmp27_;
			ValaDataType* _tmp28_;
			ValaDataType* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
			gint _tmp32_;
			_tmp26_ = builder;
			_tmp27_ = delegate_symbol;
			_tmp28_ = vala_delegate_get_sender_type (_tmp27_);
			_tmp29_ = _tmp28_;
			_tmp30_ = vala_data_type_to_qualified_string (_tmp29_, NULL);
			_tmp31_ = _tmp30_;
			g_string_append (_tmp26_, _tmp31_);
			_g_free0 (_tmp31_);
			_tmp32_ = i;
			i = _tmp32_ + 1;
		}
	}
	{
		ValaList* _param_list = NULL;
		ValaList* _tmp33_;
		ValaList* _tmp34_;
		gint _param_size = 0;
		ValaList* _tmp35_;
		gint _tmp36_;
		gint _tmp37_;
		gint _param_index = 0;
		_tmp33_ = vala_data_type_get_parameters ((ValaDataType*) self);
		_tmp34_ = _vala_iterable_ref0 (_tmp33_);
		_param_list = _tmp34_;
		_tmp35_ = _param_list;
		_tmp36_ = vala_collection_get_size ((ValaCollection*) _tmp35_);
		_tmp37_ = _tmp36_;
		_param_size = _tmp37_;
		_param_index = -1;
		while (TRUE) {
			ValaParameter* param = NULL;
			ValaList* _tmp38_;
			gpointer _tmp39_;
			ValaParameter* _tmp41_;
			gboolean _tmp42_;
			gboolean _tmp43_;
			ValaParameter* _tmp45_;
			gboolean _tmp46_;
			gboolean _tmp47_;
			ValaParameter* _tmp49_;
			ValaParameterDirection _tmp50_;
			ValaParameterDirection _tmp51_;
			GString* _tmp76_;
			ValaParameter* _tmp77_;
			ValaDataType* _tmp78_;
			ValaDataType* _tmp79_;
			gchar* _tmp80_;
			gchar* _tmp81_;
			ValaParameter* _tmp82_;
			ValaExpression* _tmp83_;
			ValaExpression* _tmp84_;
			gint _tmp92_;
			_param_index = _param_index + 1;
			if (!(_param_index < _param_size)) {
				break;
			}
			_tmp38_ = _param_list;
			_tmp39_ = vala_list_get (_tmp38_, _param_index);
			param = (ValaParameter*) _tmp39_;
			if (i > 1) {
				GString* _tmp40_;
				_tmp40_ = builder;
				g_string_append (_tmp40_, ", ");
			}
			_tmp41_ = param;
			_tmp42_ = vala_parameter_get_ellipsis (_tmp41_);
			_tmp43_ = _tmp42_;
			if (_tmp43_) {
				GString* _tmp44_;
				_tmp44_ = builder;
				g_string_append (_tmp44_, "...");
				_vala_code_node_unref0 (param);
				continue;
			}
			_tmp45_ = param;
			_tmp46_ = vala_parameter_get_params_array (_tmp45_);
			_tmp47_ = _tmp46_;
			if (_tmp47_) {
				GString* _tmp48_;
				_tmp48_ = builder;
				g_string_append (_tmp48_, "params ");
			}
			_tmp49_ = param;
			_tmp50_ = vala_parameter_get_direction (_tmp49_);
			_tmp51_ = _tmp50_;
			if (_tmp51_ == VALA_PARAMETER_DIRECTION_IN) {
				ValaParameter* _tmp52_;
				ValaDataType* _tmp53_;
				ValaDataType* _tmp54_;
				gboolean _tmp55_;
				gboolean _tmp56_;
				_tmp52_ = param;
				_tmp53_ = vala_variable_get_variable_type ((ValaVariable*) _tmp52_);
				_tmp54_ = _tmp53_;
				_tmp55_ = vala_data_type_get_value_owned (_tmp54_);
				_tmp56_ = _tmp55_;
				if (_tmp56_) {
					GString* _tmp57_;
					_tmp57_ = builder;
					g_string_append (_tmp57_, "owned ");
				}
			} else {
				ValaParameter* _tmp58_;
				ValaParameterDirection _tmp59_;
				ValaParameterDirection _tmp60_;
				gboolean _tmp66_ = FALSE;
				ValaParameter* _tmp67_;
				ValaDataType* _tmp68_;
				ValaDataType* _tmp69_;
				gboolean _tmp70_;
				gboolean _tmp71_;
				_tmp58_ = param;
				_tmp59_ = vala_parameter_get_direction (_tmp58_);
				_tmp60_ = _tmp59_;
				if (_tmp60_ == VALA_PARAMETER_DIRECTION_REF) {
					GString* _tmp61_;
					_tmp61_ = builder;
					g_string_append (_tmp61_, "ref ");
				} else {
					ValaParameter* _tmp62_;
					ValaParameterDirection _tmp63_;
					ValaParameterDirection _tmp64_;
					_tmp62_ = param;
					_tmp63_ = vala_parameter_get_direction (_tmp62_);
					_tmp64_ = _tmp63_;
					if (_tmp64_ == VALA_PARAMETER_DIRECTION_OUT) {
						GString* _tmp65_;
						_tmp65_ = builder;
						g_string_append (_tmp65_, "out ");
					}
				}
				_tmp67_ = param;
				_tmp68_ = vala_variable_get_variable_type ((ValaVariable*) _tmp67_);
				_tmp69_ = _tmp68_;
				_tmp70_ = vala_data_type_get_value_owned (_tmp69_);
				_tmp71_ = _tmp70_;
				if (!_tmp71_) {
					ValaParameter* _tmp72_;
					ValaDataType* _tmp73_;
					ValaDataType* _tmp74_;
					_tmp72_ = param;
					_tmp73_ = vala_variable_get_variable_type ((ValaVariable*) _tmp72_);
					_tmp74_ = _tmp73_;
					_tmp66_ = VALA_IS_REFERENCE_TYPE (_tmp74_);
				} else {
					_tmp66_ = FALSE;
				}
				if (_tmp66_) {
					GString* _tmp75_;
					_tmp75_ = builder;
					g_string_append (_tmp75_, "weak ");
				}
			}
			_tmp76_ = builder;
			_tmp77_ = param;
			_tmp78_ = vala_variable_get_variable_type ((ValaVariable*) _tmp77_);
			_tmp79_ = _tmp78_;
			_tmp80_ = vala_data_type_to_qualified_string (_tmp79_, NULL);
			_tmp81_ = _tmp80_;
			g_string_append (_tmp76_, _tmp81_);
			_g_free0 (_tmp81_);
			_tmp82_ = param;
			_tmp83_ = vala_variable_get_initializer ((ValaVariable*) _tmp82_);
			_tmp84_ = _tmp83_;
			if (_tmp84_ != NULL) {
				GString* _tmp85_;
				GString* _tmp86_;
				ValaParameter* _tmp87_;
				ValaExpression* _tmp88_;
				ValaExpression* _tmp89_;
				gchar* _tmp90_;
				gchar* _tmp91_;
				_tmp85_ = builder;
				g_string_append (_tmp85_, " = ");
				_tmp86_ = builder;
				_tmp87_ = param;
				_tmp88_ = vala_variable_get_initializer ((ValaVariable*) _tmp87_);
				_tmp89_ = _tmp88_;
				_tmp90_ = vala_code_node_to_string ((ValaCodeNode*) _tmp89_);
				_tmp91_ = _tmp90_;
				g_string_append (_tmp86_, _tmp91_);
				_g_free0 (_tmp91_);
			}
			_tmp92_ = i;
			i = _tmp92_ + 1;
			_vala_code_node_unref0 (param);
		}
		_vala_iterable_unref0 (_param_list);
	}
	_tmp93_ = builder;
	g_string_append_c (_tmp93_, ')');
	_tmp94_ = g_direct_equal;
	_tmp95_ = vala_array_list_new (VALA_TYPE_DATA_TYPE, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, _tmp94_);
	error_types = _tmp95_;
	_tmp96_ = error_types;
	vala_code_node_get_error_types ((ValaCodeNode*) self, (ValaCollection*) _tmp96_, NULL);
	_tmp97_ = error_types;
	_tmp98_ = vala_collection_get_size ((ValaCollection*) _tmp97_);
	_tmp99_ = _tmp98_;
	if (_tmp99_ > 0) {
		GString* _tmp100_;
		gboolean first = FALSE;
		_tmp100_ = builder;
		g_string_append (_tmp100_, " throws ");
		first = TRUE;
		{
			ValaArrayList* _type_list = NULL;
			ValaArrayList* _tmp101_;
			ValaArrayList* _tmp102_;
			gint _type_size = 0;
			ValaArrayList* _tmp103_;
			gint _tmp104_;
			gint _tmp105_;
			gint _type_index = 0;
			_tmp101_ = error_types;
			_tmp102_ = _vala_iterable_ref0 (_tmp101_);
			_type_list = _tmp102_;
			_tmp103_ = _type_list;
			_tmp104_ = vala_collection_get_size ((ValaCollection*) _tmp103_);
			_tmp105_ = _tmp104_;
			_type_size = _tmp105_;
			_type_index = -1;
			while (TRUE) {
				ValaDataType* type = NULL;
				ValaArrayList* _tmp106_;
				gpointer _tmp107_;
				GString* _tmp109_;
				ValaDataType* _tmp110_;
				gchar* _tmp111_;
				gchar* _tmp112_;
				_type_index = _type_index + 1;
				if (!(_type_index < _type_size)) {
					break;
				}
				_tmp106_ = _type_list;
				_tmp107_ = vala_list_get ((ValaList*) _tmp106_, _type_index);
				type = (ValaDataType*) _tmp107_;
				if (!first) {
					GString* _tmp108_;
					_tmp108_ = builder;
					g_string_append (_tmp108_, ", ");
				} else {
					first = FALSE;
				}
				_tmp109_ = builder;
				_tmp110_ = type;
				_tmp111_ = vala_code_node_to_string ((ValaCodeNode*) _tmp110_);
				_tmp112_ = _tmp111_;
				g_string_append (_tmp109_, _tmp112_);
				_g_free0 (_tmp112_);
				_vala_code_node_unref0 (type);
			}
			_vala_iterable_unref0 (_type_list);
		}
	}
	_tmp113_ = builder;
	_tmp114_ = _tmp113_->str;
	_tmp115_ = g_strdup (_tmp114_);
	result = _tmp115_;
	_vala_iterable_unref0 (error_types);
	_g_free0 (_tmp9_);
	_g_string_free0 (builder);
	return result;
}

static void
vala_callable_type_class_init (ValaCallableTypeClass * klass,
                               gpointer klass_data)
{
	vala_callable_type_parent_class = g_type_class_peek_parent (klass);
	((ValaDataTypeClass *) klass)->is_invokable = (gboolean (*) (ValaDataType*)) vala_callable_type_real_is_invokable;
	((ValaDataTypeClass *) klass)->get_return_type = (ValaDataType* (*) (ValaDataType*)) vala_callable_type_real_get_return_type;
	((ValaDataTypeClass *) klass)->get_parameters = (ValaList* (*) (ValaDataType*)) vala_callable_type_real_get_parameters;
	((ValaDataTypeClass *) klass)->to_prototype_string = (gchar* (*) (ValaDataType*, const gchar*)) vala_callable_type_real_to_prototype_string;
}

static void
vala_callable_type_instance_init (ValaCallableType * self,
                                  gpointer klass)
{
}

/**
 * A callable type, i.e. a delegate, method, or signal type.
 */
static GType
vala_callable_type_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ValaCallableTypeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_callable_type_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaCallableType), 0, (GInstanceInitFunc) vala_callable_type_instance_init, NULL };
	GType vala_callable_type_type_id;
	vala_callable_type_type_id = g_type_register_static (VALA_TYPE_DATA_TYPE, "ValaCallableType", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return vala_callable_type_type_id;
}

GType
vala_callable_type_get_type (void)
{
	static volatile gsize vala_callable_type_type_id__volatile = 0;
	if (g_once_init_enter (&vala_callable_type_type_id__volatile)) {
		GType vala_callable_type_type_id;
		vala_callable_type_type_id = vala_callable_type_get_type_once ();
		g_once_init_leave (&vala_callable_type_type_id__volatile, vala_callable_type_type_id);
	}
	return vala_callable_type_type_id__volatile;
}

